import 'package:fastor_app_ui_widget/resource/ds/LevelDS.dart';


import 'package:flutter/material.dart';

import 'package:fastor_app_ui_widget/resource/ds/DesignSystemColor.dart';
import 'package:fastor_app_ui_widget/resource/ds/DesignSystemDimen.dart';

import 'TextFieldTemplateBase.dart';

class TextFieldTemplate   {



  static Widget t(
      {
        // String?  text ,
        FormFieldValidator<String>? validator,
        AutovalidateMode? autovalidateMode,
        String? hint_text,
        Color? text_color,
        double? fontSize,
        Color? hint_color,
        bool isRemoveUnderline = false,
        Color? background_color,
        TextEditingController? controller,
        EdgeInsets? padding,
        EdgeInsets? margin,
        Decoration? decoration,
        ValueChanged<String>? onChanged,
        TextInputType? keyboardType,
        bool obscureText = false,
        String? error_text = "Missed",
        double? width,
        TextAlign? textAlign  ,
        int? maxLength,
        FocusNode? focusNode,
      }) {

    //padding default
    padding ??= EdgeInsets.zero;

    //hint color
    hint_color ??= DSColor.ds_textfield_hint;

    //text color
    text_color ??= DSColor.ds_textfield_text;

    //text size
    fontSize ??= DSDimen.text_level_2;

    //align
    textAlign ??= TextAlign.start;

    //password
    bool isPass = keyboardType != null && keyboardType == TextInputType.visiblePassword;
    if(  isPass) {
      obscureText = true;
    }

    //get tf
    TextFormField tf = _getTextFourmField(obscureText, autovalidateMode, error_text,
        validator, text_color, fontSize, hint_color,
        padding, hint_text, keyboardType, controller, onChanged,
        textAlign , maxLength, focusNode );


    //fix textfield not materail
    var materialApp = Material(
      child: tf,
      color: background_color,
    );


    //ct
    var ct = TextFieldTemplateBase.getContainer( materialApp, width, margin, decoration);
    return ct;
  }


  static TextFormField _getTextFourmField(bool obscureText,
      AutovalidateMode? autovalidateMode, String? error_text, FormFieldValidator<String>? validator,
      Color text_color, double fontSize, Color hint_color,
      EdgeInsets padding, String? hint_text, TextInputType? keyboardType,
      TextEditingController? controller, ValueChanged<String>? onChanged,
      TextAlign  textAlign, int? maxLength, FocusNode? focusNode){

    //textfield
    var tf = TextFormField (

      //password keyboard
      obscureText : obscureText,
      autovalidateMode: autovalidateMode,

      textAlign: textAlign ,

      //validate error
      validator:  TextFieldTemplateBase.getTextValidator(error_text!, validator),

      //text style
      style: TextStyle( color: text_color, fontSize: fontSize),

      //cursor color
      cursorColor: hint_color,

      //padding + hint + underline
      decoration: TextFieldTemplateBase.getDecorationInput(padding, hint_text, hint_color, fontSize ),

      //keyboard
      keyboardType: keyboardType, //TextInputType.number

      //controller
      controller: controller,

      //change
      onChanged: onChanged,

      //submit
      onFieldSubmitted: onChanged,

      //max
      maxLength: maxLength,
      buildCounter: (BuildContext context, {int? currentLength, int? maxLength, bool? isFocused}) => null,

      focusNode: focusNode,

    );

    return tf;
  }

}